library(dplyr)
library(magrittr)
library(vegan)
library(tidyverse)

################################################################################################################################
##Simpson Diversity for overall 1072 data
mr_all_data <- read.csv("~/Downloads/MR_data_K & O Loci _1072.csv")

# Group the data by 'Region/Province/Department' and calculate the Simpson's Diversity Index for each group
diversity_by_region_K_all_data <- mr_all_data %>%
  group_by(`Regions`) %>%
  summarize(
    Simpson_Diversity_Index = 1 - sum((table(K_locus) / sum(table(K_locus)))^2)
  )

print(diversity_by_region_K_all_data)

# Group the data by 'Age' and calculate the Simpson's Diversity Index for each group
diversity_by_age_K_all_data <- mr_all_data %>%
  group_by(`Age_group`) %>%
  summarize(
    Simpson_Diversity_Index = 1 - sum((table(K_locus) / sum(table(K_locus)))^2)
  )

print(diversity_by_age_K_all_data)


#################################################################################################################

# Group the data by 'Region/Province/Department' and calculate the Simpson's Diversity Index for each group
diversity_by_region_O_all_data <- mr_all_data %>%
  group_by(`Regions`) %>%
  summarize(
    Simpson_Diversity_Index = 1 - sum((table(O_locus) / sum(table(O_locus)))^2)
  )

# View the resulting data frame
print(diversity_by_region_O_all_data)




#################################################################################################################################################
#Load the dereplicated MR data
derep_data <- read.csv("~/Downloads/Derplicated_MR.csv")

#####Simpson DIversity for derplicated data
#Method1 calculating Simpson Diversity by formula
# Group the data by 'Region/Province/Department' and calculate the Simpson's Diversity Index for each group
diversity_by_region_K_derep_data <- derep_data %>%
  group_by(`Regions`) %>%
  summarize(
    Simpson_Diversity_Index = 1 - sum((table(K_locus) / sum(table(K_locus)))^2)
  )

print(diversity_by_region_K_derep_data)

# Group the data by 'Sge' and calculate the Simpson's Diversity Index for each group
diversity_by_age_K_derep_data <- derep_data %>%
  group_by(`Age_group`) %>%
  summarize(
    Simpson_Diversity_Index = 1 - sum((table(K_locus) / sum(table(K_locus)))^2)
  )

print(diversity_by_age_K_derep_data)



# Group the data by 'Region/Province/Department' and calculate the Simpson's Diversity Index for each group of Olocus
diversity_by_region_O_derep <- derep_data %>%
  group_by(`Regions`) %>%
  summarize(
    Simpson_Diversity_Index = 1 - sum((table(O_locus) / sum(table(O_locus)))^2)
  )

# View the resulting data frame
print(diversity_by_region_O_derep)



#Methods 2 calculating Simpson Diversity by vegan package JUST FOR Reconfirmation 
# Create a table of counts of K_locus per region
k_locus_table_derep <- table(derep_data$Regions, derep_data$K_locus)

print(k_locus_table_derep)

# Step 4: Calculate the Simpson Diversity Index for each region
# Use the diversity function from the vegan package
simpson_diversity_derep <- apply(k_locus_table_derep, 1, function(x) diversity(x, index = "simpson"))

# Print the Simpson Diversity Index for each region
print(simpson_diversity_derep)



################################################################################################################################



